
package de.ivu.elect.presentation.stimmeingabe.exchange;

import java.util.List;

import javax.inject.Inject;
import javax.inject.Named;

import de.ivu.elect.business.datei.entity.DateiImportBerichtCustomData;
import de.ivu.elect.business.exchange.control.AbstractImporter;
import de.ivu.elect.business.security.UseCasePermission;
import de.ivu.elect.business.stimmeingabe.boundary.StimmeingabeImporter;
import de.ivu.elect.business.stimmeingabe.control.StimmeingabeImportContext;
import de.ivu.elect.business.stimmeingabe.entity.Ergebniseingang;
import de.ivu.elect.business.wahl.boundary.WahldurchfuehrungSessionSelect;
import de.ivu.elect.presentation.View;
import de.ivu.elect.presentation.exchange.AbstractImportSearchView;
import de.ivu.elect.presentation.exchange.ImportDescription;
import de.ivu.elect.presentation.hilfe.OnlineHilfeId;

@OnlineHilfeId(value = "341", mehrfachVergebenOk = true)
@Named(StimmeingabeImportSearchView.COMPONENT_NAME)
@View(viewId = StimmeingabeImportSearchView.VIEW_ID, useCase = UseCasePermission.STIMMEINGABE_IMPORTIEREN)
public class StimmeingabeImportSearchView extends AbstractImportSearchView<List<Ergebniseingang>, StimmeingabeImportContext> {

  public static final String COMPONENT_NAME = "stimmeingabeImportSearchView";

  public static final String VIEW_ID = "/stimmeingabe/stimmeingabe-import-search.xhtml";

  private static final long serialVersionUID = 1L;

  @Inject
  transient WahldurchfuehrungSessionSelect wahldurchfuehrungSessionSelect;

  @Inject
  transient StimmeingabeImporter importer;

  @Inject
  transient StimmeingabeImportDescription importDescription;

  @Override
  protected ImportDescription getImportDescription() {
    return importDescription;
  }

  @Override
  protected AbstractImporter<List<Ergebniseingang>, StimmeingabeImportContext, ? > getImporter() {
    return importer;
  }

  @Override
  protected StimmeingabeImportContext getContext() {
    return new StimmeingabeImportContext(wahldurchfuehrungSessionSelect.getEntity(), getPrincipal());
  }

  @Override
  protected DateiImportBerichtCustomData createNewDateiImportBerichtCustomData() {
    return new DateiImportBerichtCustomData();
  }

  public String getPageTitle() {
    return getMessage("stimmeingabe.import.page.title");
  }

  public String getPageHeader() {
    return getMessage("stimmeingabe.import.page.header");
  }
}
